N+1 query on compute resource image list

11/26/2014 04:32 AM - Dominic Cleal

Status: Closed   

Priority: Normal   

Assignee: Tom Caspy   

Category: Database   

Target version: 1.7.1   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/1994

  

Description

Seen on the compute resource view page, when loading the images tab over AJAX.

Started GET "/compute_resources/8-example/images" for 127.0.0.1 at 2014-11-26 09:27:14 +0000

Processing by ImagesController#index as HTML

  Parameters: {"compute_resource_id"=>"8-example"}

  User Load (0.2ms)  SELECT "users".* FROM "users" WHERE "users"."id" = ? LIMIT 1  [["id", 24]]

Setting current user thread-local variable to admin

  AuthSource Load (0.2ms)  SELECT "auth_sources".* FROM "auth_sources" WHERE "auth_sources"."id" =

 1 LIMIT 1

  Image Load (0.1ms)  SELECT "images".* FROM "images" LIMIT 1

  ComputeResource Load (0.1ms)  SELECT "compute_resources".* FROM "compute_resources" WHERE "compu

te_resources"."id" = ? ORDER BY compute_resources.name LIMIT 1  [["id", "8-example"]]

  Image Load (0.5ms)  SELECT "images".* FROM "images" WHERE "images"."compute_resource_id" = 8 LIM

IT 10 OFFSET 0

  Operatingsystem Load (0.2ms)  SELECT "operatingsystems".* FROM "operatingsystems" WHERE "operati

ngsystems"."id" = 6 ORDER BY operatingsystems.name LIMIT 1

  CACHE (0.0ms)  SELECT "operatingsystems".* FROM "operatingsystems" WHERE "operatingsystems"."id"

 = 6 ORDER BY operatingsystems.name LIMIT 1

  Rendered images/index.html.erb within layouts/application (24.3ms)

  Rendered home/_user_dropdown.html.erb (1.5ms)

  Rendered home/_org_switcher.html.erb (0.0ms)

  Rendered home/_submenu.html.erb (1.7ms)

  Rendered home/_submenu.html.erb (2.4ms)

  Rendered home/_submenu.html.erb (1.7ms)

  Rendered home/_submenu.html.erb (1.6ms)

  Rendered home/_submenu.html.erb (1.9ms)

  Rendered home/_topbar.html.erb (17.1ms)

  Rendered layouts/base.html.erb (47.9ms)

Completed 200 OK in 98.5ms (Views: 75.2ms | ActiveRecord: 1.2ms)

user: dcleal

http://0.0.0.0:3000/compute_resources/8-example/images

N+1 Query detected

  Image => [:operatingsystem]

  Add to your finder: :include => [:operatingsystem]

N+1 Query method call stack

  /home/dcleal/code/foreman/foreman/app/views/images/index.html.erb:19:in `block in _app_views_ima

ges_index_html_erb___1356502804056466923_78463940'

  /home/dcleal/code/foreman/foreman/app/views/images/index.html.erb:16:in `_app_views_images_index

_html_erb___1356502804056466923_78463940'

  /home/dcleal/code/foreman/foreman/app/models/concerns/foreman/thread_session.rb:33:in `clear_thr

ead'

  /home/dcleal/code/foreman/foreman/lib/middleware/catch_json_parse_errors.rb:9:in `call'
Revision 65e7e1e4 - 12/03/2014 06:54 AM - Tom Caspy

fixes #8513 - removing n+1 query from images#index

Revision 7aacbf6e - 12/15/2014 10:00 AM - Tom Caspy

fixes #8513 - removing n+1 query from images#index

(cherry picked from commit 65e7e1e40329191a24e41368f3aea16c5a4cd7b6)

History

#1 - 12/03/2014 05:29 AM - Tom Caspy

- Status changed from New to Assigned

- Assignee set to Tom Caspy

#2 - 12/03/2014 05:31 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/1994 added

- Pull request deleted ()

#3 - 12/03/2014 07:01 AM - Tom Caspy

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 65e7e1e40329191a24e41368f3aea16c5a4cd7b6.

#4 - 12/03/2014 07:02 AM - Dominic Cleal

- translation missing: en.field_release set to 29
